
XCLE_Object XCLE_ObjectScan(int fd, unsigned long * ln) {
	unsigned long lnv = 0 ;
	unsigned long off = 0 ;
	int eof, eol ;
	int olderrno
	char * buffer ;		 // read-in data buffer
	unsigned long buffallc ; // allocated size of buffer
	unsigned long buffused ; // really used size
	unsigned long buffrd ;   // read amount
	XCLE_Object obj = NULL ;
	
	if(ln==NULL) {
		ln = &lnv ;
	}
	eof = 0 ;
	buffallc = 1 ;
	buffused = 0 ;
	buffer = malloc(buffallc+1) ;
	if(buffer==NULL) {
		DbgLog("XCLE_ObjectScan",XCLE_DBGMEM,0,NULL) ;
		return NULL ;
	}
	do {
		// line reading
		eol = 0 ;
		buffline = buffused ;
		off = buffline ;
		while(!eol) {
			buffrd = read(fd,buffer+buffused,buffallc-buffused) ;
			if(buffrd==-1) {
				DbgLog("XCLE_ObjectScan",XCLE_DBGUSR,0,"Read error line %lu",*ln) ;
				free(buffer) ;
				return NULL ;
			}
			buffused += buffrd ;
			if(buffused<buffallc) {
				eof = 1 ;
				if( (buffused==0) || (buffer[buffused-1]!='\n') ) {
					buffer[buffused]='\n' ;
					buffused ++ ;
				}
			}
			else {
				char * tbuffer ;
				tbuffer = realloc(buffer,(buffallc<<1)+1) ;
				if(tbuffer==NULL) {
					DbgLog("XCLE_ObjectScan",XCLE_DBGMEM,0,NULL) ;
					return NULL ;
				}
				buffer = tbuffer ;
				buffallc = (buffallc<<1) ;
			}
			while(off<buffused) {
				if(buffer[off]=='\n') {
					buffer[off] = ' ' ;
					eol = 1 ;
					break ;
				}
				off ++ ;
			}
		}
		buffer[buffused] = '\0' ;
		// line parsing
		if(buffer[buffline]=='#') {
			buffer[off]=0 ;
			while(off<buffused) {
				buffer[buffline] = buffer[off] ;
				off ++ ;
				buffline ++ ;
			}
			buffused = buffline ;
			continue ;
		}
		off = 0 ;
		while((off<buffused)&&isblank(buffer[off])) {
			off ++ ;
		}
		if(off==buffused) {
			buffused = 0 ;
			continue ;
		}
		olderrno = errno ;
		errno = 0 ;
		obj = XCLE_ObjectParse(buffer,&off) ;
		if( (obj==NULL) && (errno==EINVAL) && ((off<buffused)||eof) ) {
			DbgLog("XCLE_ObjectScan",XCLE_DBGSTX,0,"Syntax error near \"%10s\", line %u",buffer+off,*ln) ;
			free(buffer) ;
			return NULL ;
		}
		else if( (obj==NULL) && (errno!=0) ) {
			free(buffer) ;
			return NULL ;
		}
		errno = olderrno ;
	} while((obj==NULL)&&(!eof)) ;
	free(buffer) ;
	return obj ;
}

XCLE_List XCLE_ListScan(int fd, unsigned long * ln) {
	int olderrno ;
	unsigned long lnv = 0 ;
	XCLE_List lst = NULL ;
	XCLE_Object obj ;
	lst = XCLE_ListAlloc() ;
	if(lst==NULL) {
		return NULL ;
	}
	if(ln==NULL) {
		ln = &lnv ;
	}
	while(str[*off]!=0) {
		olderrno = errno ;
		errno = 0 ;
		obj = XCLE_ObjectScan(fd,ln,flags) ;
		if((obj==NULL)&&(errno==EINVAL)) {
			DbgLog("XCLE_ListScan",XCLE_DBGSTX,0,"Syntax error line %u",*ln) ;
			XCLE_ListFree(lst) ;
			return NULL ;
		}
		else if((obj==NULL)&&(errno!=0)) {
			XCLE_ListFree(lst) ;
			return NULL ;
		}
		errno = olderrno ;
		if(XCLE_ListPush(lst,obj)==NULL) {
			XCLE_ListFree(lst) ;
			return NULL ;
		}
	}
	return lst ;
}

