.TH XCLE_Mod_exec 3 "2006-02-22" Unix Libraries



.SH NAME
.I Execution  module - Instructions manual
.PD 0
.P
.PD
---------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Return status management



.PD 1
.P
.PD
.SS Macro XCLE_EXCEPTION_OK
.PD 0
XCLE_Exception XCLE_EXCEPTION_OK ;
.PD 1
.P
.PD
The Exception returned when execution was successful.

.B
	Note
.RS
The comparison operator == can be used to test whether an XCLE_Exception
is the same as XCLE_EXCEPTION_OK (since this is a static pointer value).
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExceptionNew
.PD 0


.I XCLE_Exception
.B XCLE_ExceptionNew
(
.I unsigned
.I long
.B ident
,
.I char
.B *
.B messg
) ;

.PD 1
.P
.PD
Creates a new XCLE_Exception with the specified error number, exception identifier, and message.

.B
	Args
.RS
.IP _ 2
.I ident
	: error identifier number
.IP "" 0
.IP _ 2
.I messg
	: description of the error
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the memory could not be allocated
.IP "" 0
.IP _ 2
.I XCLE_EXCEPTION_OK
	: XCLE_ExceptionNew(0,NULL)
.IP "" 0
else a new XCLE_Exception.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if new memory could not be allocated
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExceptionCopy
.PD 0


.I XCLE_Exception
.B XCLE_ExceptionCopy
(
.I XCLE_Exception
.B exp
) ;

.PD 1
.P
.PD
Creates a memory copy of the given exception.

.B
	Args
.RS
.IP _ 2
.I exp
	: the original exception
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the memory could not be allocated
.IP "" 0
.IP _ 2
.I XCLE_EXCEPTION_OK
	: if XCLE_EXCEPTION_OK was passed as argument
.IP "" 0
else a new XCLE_Exception.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if new memory could not be allocated
.IP "" 0
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Exception was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExceptionIdent
.PD 0


.I unsigned
.I long
.B XCLE_ExceptionIdent
(
.I XCLE_Exception
.B exp
) ;

.PD 1
.P
.PD
Returns the error identifier of an exception.

.B
	Args
.RS
.IP _ 2
.I exp
	: the exception
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if a NULL XCLE_Exception was passed as argument
.IP "" 0
.IP _ 2
.I 0
	: if XCLE_EXCEPTION_OK was passed as argument
.IP "" 0
else the exception's error identifier
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Exception was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExceptionMessg
.PD 0


.I const
.I char
.B *
.B XCLE_ExceptionMessg
(
.I XCLE_Exception
.B exp
) ;

.PD 1
.P
.PD
Returns the message string of an exception.

.B
	Args
.RS
.IP _ 2
.I exp
	: the exception
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a NULL XCLE_Exception was passed as argument
.IP "" 0
.IP _ 2
.I ""
	: if XCLE_EXCEPTION_OK was passed as argument
.IP "" 0
else the exception's message string
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Exception was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExceptionFree
.PD 0


.I void
.B XCLE_ExceptionFree
(
.I XCLE_Exception
.B exp
) ;

.PD 1
.P
.PD
Frees an XCLE_Exception.

.B
	Args
.RS
.IP _ 2
.I exp
	: XCLE_Exception to free
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Freeing XCLE_EXCEPTION_OK using XCLE_ExceptionFree does nothing
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExecCtxAlloc
.PD 0


.I XCLE_ExecCtx
.B XCLE_ExecCtxAlloc
(
.I unsigned
.I long
.B chksz
) ;

.PD 1
.P
.PD
Allocates an execution context.

.B
	Args
.RS
.IP _ 2
.I chksz
	: the chunk size used for the exception stack
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the memory could not be allocated
.IP "" 0
else a new, empty, execution context.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if new memory could not be allocated
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExecCtxFree
.PD 0


.I void
.B XCLE_ExecCtxFree
(
.I XCLE_ExecCtx
.B ctx
) ;

.PD 1
.P
.PD
Frees an execution context, along any eventual pending exception.

.B
	Args
.RS
.IP _ 2
.I ctx
	: the execution context to free
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExecCtxThrow
.PD 0


.I XCLE_ExecCtx
.B XCLE_ExecCtxThrow
(
.I XCLE_ExecCtx
.B ctx
,
.I char
.B *
.B src
,
.I XCLE_Exception
.B exp
) ;

.PD 1
.P
.PD
Throws an exception in this context.

.B
	Args
.RS
.IP _ 2
.I ctx
	: the execution context
.IP "" 0
.IP _ 2
.I src
	: the name of the calling code
.IP "" 0
.IP _ 2
.I exp
	: the exception to throw
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if 'ctx', 'src', or 'exp' were NULL
.IP "" 0
else the original context, with the exception added to the pending queue
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if new memory could not be allocated
.IP "" 0
.IP _ 2
.I EINVAL
	: if 'ctx', 'src', or 'exp' were NULL
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Nothing is done if exp is XCLE_EXCEPTION_OK.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExecCtxCatch
.PD 0


.I XCLE_Exception
.B XCLE_ExecCtxCatch
(
.I XCLE_ExecCtx
.B ctx
) ;

.PD 1
.P
.PD
Catches the last thrown exception.

.B
	Args
.RS
.IP _ 2
.I ctx
	: the execution context
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the execution context was NULL
.IP "" 0
.IP _ 2
.I XCLE_EXCEPTION_OK
	: if no exception was pending in this context
.IP "" 0
else the last thrown exception
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if the execution context was NULL
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExecCtxClear
.PD 0


.I XCLE_ExecCtx
.B XCLE_ExecCtxClear
(
.I XCLE_ExecCtx
.B ctx
) ;

.PD 1
.P
.PD
Clears all pending exceptions in this context.

.B
	Args
.RS
.IP _ 2
.I ctx
	: the execution context
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the execution context was NULL
.IP "" 0
else the original execution context
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if the execution context was NULL
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ExecCtxMapExceptions
.PD 0


.I unsigned
.I long
.B XCLE_ExecCtxMapExceptions
(
.I XCLE_ExecCtx
.B ctx
,
.B 
,
.I void
.B *
.B dat
) ;

.PD 1
.P
.PD
Maps all pending exceptions in an execution context (e.g. for displaying).

.B
	Args
.RS
.IP _ 2
.I ctx
	: the execution context
.IP "" 0
.IP _ 2
.I map
	: the mapping handler
.IP "" 0
.IP _ 2
.I dat
	: user-data pointer
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the execution context or the map handler were NULL
.IP "" 0
else the sum of all values returned by 'map'
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if the execution context or the map handler were NULL
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The map handler takes, in order, the informations pertaining to the exception's
calling code, and the exception nature:
.IP _ 2
.I lev
	: the depth of the currently mapped exception (0 for the root exception)
.IP "" 0
.IP _ 2
.I src
	: the name of the calling code
.IP "" 0
.IP _ 2
.I idt
	: the exception's identification number
.IP "" 0
.IP _ 2
.I msg
	: the exception's description
.IP "" 0
.IP _ 2
.I dat
	: user-defined data pointer (the last argument of XCLE_ExecCtxMapExceptions)
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Typedef XCLE_CodeOperator
.PD 0
typedef XCLE_Exception (* XCLE_CodeOperator) (XCLE_ExecCtx, XCLE_Stack, XCLE_Hash, XCLE_Object) ;
.PD 1
.P
.PD
The type of the handler segment of Code objects for them to be compatible with this module.

.B
	
.RS
.RE
.PD 1
.P
.PD









.SH Object evaluation



.PD 1
.P
.PD
.SS Function XCLE_ObjectEval
.PD 0


.I XCLE_Exception
.B XCLE_ObjectEval
(
.I XCLE_ExecCtx
.B ctx
,
.I XCLE_Stack
.B stk
,
.I XCLE_Hash
.B hsh
,
.I XCLE_Object
.B obj
) ;

.PD 1
.P
.PD
Evaluates an XCLE_Object.

.B
	Args
.RS
.IP _ 2
.I ctx
	: execution context
.IP "" 0
.IP _ 2
.I stk
	: Stack environment
.IP "" 0
.IP _ 2
.I dom
	: Variables environment
.IP "" 0
.IP _ 2
.I obj
	: Object to execute
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a NULL Stack, Hash or Object was passed as argument
.IP "" 0
.IP _ 2
.I XCLE_EXCEPTION_OK
	: if the execution terminated normally
.IP "" 0
else the last exception thrown in this context.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Stack, Hash or Object was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ListEval
.PD 0


.I XCLE_Exception
.B XCLE_ListEval
(
.I XCLE_ExecCtx
.B ctx
,
.I XCLE_Stack
.B stk
,
.I XCLE_Hash
.B hsh
,
.I XCLE_List
.B lst
) ;

.PD 1
.P
.PD
Evaluates an XCLE_List.

.B
	Args
.RS
.IP _ 2
.I ctx
	: execution context
.IP "" 0
.IP _ 2
.I stk
	: Stack environment
.IP "" 0
.IP _ 2
.I dom
	: Variables environment
.IP "" 0
.IP _ 2
.I lst
	: list to execute
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a NULL Stack, Hash or Object was passed as argument
.IP "" 0
.IP _ 2
.I XCLE_EXCEPTION_OK
	: if the execution terminated normally
.IP "" 0
else the last exception thrown in this context.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Stack, Hash or Object was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_CodeEval
.PD 0


.I XCLE_Exception
.B XCLE_CodeEval
(
.I XCLE_ExecCtx
.B ctx
,
.I XCLE_Stack
.B stk
,
.I XCLE_Hash
.B hsh
,
.I XCLE_Code
.B cod
) ;

.PD 1
.P
.PD
Evaluates an XCLE_Code object.

.B
	Args
.RS
.IP _ 2
.I ctx
	: execution context
.IP "" 0
.IP _ 2
.I stk
	: Stack environment
.IP "" 0
.IP _ 2
.I dom
	: Variables environment
.IP "" 0
.IP _ 2
.I cod
	: code to execute
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a NULL Stack, Hash or Object was passed as argument
.IP "" 0
.IP _ 2
.I XCLE_EXCEPTION_OK
	: if the execution terminated normally
.IP "" 0
else the last exception thrown in this context.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Stack, Hash or Object was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD








