.TH XCLE_Mod_fileIO 3 "2006-02-22" Unix Libraries



.SH NAME
.I File IO module - Instructions manual
.PD 0
.P
.PD
------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Objects File-descriptor Printing



.PD 1
.P
.PD
.SS Function XCLE_ObjectPrint
.PD 0


.I unsigned
.I long
.B XCLE_ObjectPrint
(
.I XCLE_Object
.B obj
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_Object into a file descriptor.

.B
	Args
.RS
.IP _ 2
.I obj
	: XCLE_Object to print
.IP "" 0
.IP _ 2
.I fd
	: output file descriptor output file descriptor
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occurred
.IP "" 0
else the total number of characters printed
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Object was passed as argument
.IP "" 0
or any error generated by the 'write' system call on file descriptor 'fd'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_VoidPrint
.PD 0


.I unsigned
.I long
.B XCLE_VoidPrint
(
.I XCLE_Void
.B vd
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_Void into a file descriptor.

.B
	Args
.RS
.IP _ 2
.I vd
	: XCLE_Void to print
.IP "" 0
.IP _ 2
.I fd
	: output file descriptor output file descriptor
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else the total number of characters printed
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'write' system call on file descriptor 'fd'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgPrint
.PD 0


.I unsigned
.I long
.B XCLE_IntgPrint
(
.I XCLE_Intg
.B in
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_Intg into a file descriptor.

.B
	Args
.RS
.IP _ 2
.I in
	: XCLE_Intg to print
.IP "" 0
.IP _ 2
.I fd
	: output file descriptor output file descriptor
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else the total number of characters printed
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'write' system call on file descriptor 'fd'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpPrint
.PD 0


.I unsigned
.I long
.B XCLE_FltpPrint
(
.I XCLE_Fltp
.B fp
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_Fltp into a file descriptor.

.B
	Args
.RS
.IP _ 2
.I fp
	: XCLE_Fltp to print
.IP "" 0
.IP _ 2
.I fd
	: output file descriptor 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'write' system call on file descriptor 'fd'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgPrint
.PD 0


.I unsigned
.I long
.B XCLE_StrgPrint
(
.I XCLE_Strg
.B str
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_Strg into a file descriptor.

.B
	Args
.RS
.IP _ 2
.I str
	: XCLE_Strg to print
.IP "" 0
.IP _ 2
.I fd
	: output file descriptor 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'write' system call on file descriptor 'fd'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ListPrint
.PD 0


.I unsigned
.I long
.B XCLE_ListPrint
(
.I XCLE_List
.B lst
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_List into a file descriptor.

.B
	Args
.RS
.IP _ 2
.I lst
	: XCLE_List to print
.IP "" 0
.IP _ 2
.I fd
	: output file descriptor 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'write' system call on file descriptor 'fd'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_CodePrint
.PD 0


.I unsigned
.I long
.B XCLE_CodePrint
(
.I XCLE_Code
.B cod
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_Code into a file descriptor.

.B
	Args
.RS
.IP _ 2
.I cod
	: XCLE_Code to print
.IP "" 0
.IP _ 2
.I fd
	: output file descriptor 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'write' system call on file descriptor 'fd'
.RE
.PD 1
.P
.PD






.SH Objects Stream Printing



.PD 1
.P
.PD
.SS Function XCLE_ObjectFPrint
.PD 0


.I unsigned
.I long
.B XCLE_ObjectFPrint
(
.I XCLE_Object
.B obj
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_Object into an output stream.

.B
	Args
.RS
.IP _ 2
.I obj
	: XCLE_Object to print
.IP "" 0
.IP _ 2
.I os
	: output stream output file descriptor
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occurred
.IP "" 0
else the total number of characters printed
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Object was passed as argument
.IP "" 0
or any error generated by the 'fwrite' system call on stream 'os'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_VoidFPrint
.PD 0


.I unsigned
.I long
.B XCLE_VoidFPrint
(
.I XCLE_Void
.B vd
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_Void into an output stream.

.B
	Args
.RS
.IP _ 2
.I vd
	: XCLE_Void to print
.IP "" 0
.IP _ 2
.I os
	: output stream output file descriptor
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else the total number of characters printed
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'fwrite' system call on stream 'os'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgFPrint
.PD 0


.I unsigned
.I long
.B XCLE_IntgFPrint
(
.I XCLE_Intg
.B in
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_Intg into an output stream.

.B
	Args
.RS
.IP _ 2
.I in
	: XCLE_Intg to print
.IP "" 0
.IP _ 2
.I os
	: output stream output file descriptor
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else the total number of characters printed
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'fwrite' system call on stream 'os'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpFPrint
.PD 0


.I unsigned
.I long
.B XCLE_FltpFPrint
(
.I XCLE_Fltp
.B fp
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_Fltp into an output stream.

.B
	Args
.RS
.IP _ 2
.I fp
	: XCLE_Fltp to print
.IP "" 0
.IP _ 2
.I os
	: output stream 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'fwrite' system call on stream 'os'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgFPrint
.PD 0


.I unsigned
.I long
.B XCLE_StrgFPrint
(
.I XCLE_Strg
.B str
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_Strg into an output stream.

.B
	Args
.RS
.IP _ 2
.I str
	: XCLE_Strg to print
.IP "" 0
.IP _ 2
.I os
	: output stream 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'fwrite' system call on stream 'os'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ListFPrint
.PD 0


.I unsigned
.I long
.B XCLE_ListFPrint
(
.I XCLE_List
.B lst
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_List into an output stream.

.B
	Args
.RS
.IP _ 2
.I lst
	: XCLE_List to print
.IP "" 0
.IP _ 2
.I os
	: output stream 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'fwrite' system call on stream 'os'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_CodeFPrint
.PD 0


.I unsigned
.I long
.B XCLE_CodeFPrint
(
.I XCLE_Code
.B cod
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_Code into an output stream.

.B
	Args
.RS
.IP _ 2
.I cod
	: XCLE_Code to print
.IP "" 0
.IP _ 2
.I os
	: output stream 
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
or any error generated by the 'fwrite' system call on stream 'os'
.RE
.PD 1
.P
.PD






.SH Stack and Hash Printing



.PD 1
.P
.PD
.SS Function XCLE_StackPrintF
.PD 0


.I unsigned
.I long
.B XCLE_StackPrintF
(
.I XCLE_Stack
.B stk
,
.I int
.B fd
,
.I char
.B *
.B head
,
.I char
.B *
.B rowfmt
,
.I char
.B *
.B tail
,
.I unsigned
.I long
.B rows
) ;

.PD 1
.P
.PD
Prints the contents of an XCLE_Stack in a file descriptor, following the given formats.

.B
	Args
.RS
.IP _ 2
.I stk
	: XCLE_Stack
.IP "" 0
.IP _ 2
.I fd
	: file descriptor
.IP "" 0
.IP _ 2
.I head
	: head string
.IP "" 0
.IP _ 2
.I rowfmt
	: row printing format
.IP "" 0
.IP _ 2
.I tail
	: tail string
.IP "" 0
.IP _ 2
.I rows
	: number of rows (height in chars)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occurred
.IP "" 0
else the number of characters printed.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Stack was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_HashPrintF
.PD 0


.I unsigned
.I long
.B XCLE_HashPrintF
(
.I XCLE_Hash
.B hsh
,
.I int
.B fd
,
.I char
.B *
.B head
,
.I char
.B *
.B rowfmt
,
.I char
.B *
.B tail
) ;

.PD 1
.P
.PD
Prints the contents of an XCLE_Hash in a file descriptor, following the given formats.

.B
	Args
.RS
.IP _ 2
.I hsh
	: XCLE_Hash
.IP "" 0
.IP _ 2
.I fd
	: file descriptor
.IP "" 0
.IP _ 2
.I head
	: head string
.IP "" 0
.IP _ 2
.I rowfmt
	: row printing format
.IP "" 0
.IP _ 2
.I tail
	: tail string
.IP "" 0
.IP _ 2
.I rows
	: number of rows (height in chars)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occurred
.IP "" 0
else the number of characters printed.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Hash was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StackFPrintF
.PD 0


.I unsigned
.I long
.B XCLE_StackFPrintF
(
.I XCLE_Stack
.B stk
,
.I FILE
.B *
.B os
,
.I char
.B *
.B head
,
.I char
.B *
.B rowfmt
,
.I char
.B *
.B tail
,
.I unsigned
.I long
.B rows
) ;

.PD 1
.P
.PD
Prints the contents of an XCLE_Stack in an output stream, following the given formats.

.B
	Args
.RS
.IP _ 2
.I stk
	: XCLE_Stack
.IP "" 0
.IP _ 2
.I os
	: output stream
.IP "" 0
.IP _ 2
.I head
	: head string
.IP "" 0
.IP _ 2
.I rowfmt
	: row printing format
.IP "" 0
.IP _ 2
.I tail
	: tail string
.IP "" 0
.IP _ 2
.I rows
	: number of rows (height in chars)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occurred
.IP "" 0
else the number of characters printed.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Stack was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_HashFPrintF
.PD 0


.I unsigned
.I long
.B XCLE_HashFPrintF
(
.I XCLE_Hash
.B hsh
,
.I int
.B fd
,
.I char
.B *
.B head
,
.I char
.B *
.B rowfmt
,
.I char
.B *
.B tail
) ;

.PD 1
.P
.PD
Prints the contents of an XCLE_Hash in an output stream, following the given formats.

.B
	Args
.RS
.IP _ 2
.I hsh
	: XCLE_Hash
.IP "" 0
.IP _ 2
.I os
	: output stream
.IP "" 0
.IP _ 2
.I head
	: head string
.IP "" 0
.IP _ 2
.I rowfmt
	: row printing format
.IP "" 0
.IP _ 2
.I tail
	: tail string
.IP "" 0
.IP _ 2
.I rows
	: number of rows (height in chars)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occurred
.IP "" 0
else the number of characters printed.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Hash was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD






.SH File-descriptor Parsing



.PD 1
.P
.PD
.SS Function XCLE_ObjectScan
.PD 0


.I XCLE_Object
.B XCLE_ObjectScan
(
.I XCLE_ParseCtx
.B contx
,
.I int
.B fd
,
.I unsigned
.I long
.B *
.B ln
) ;

.PD 1
.P
.PD
Parses an object from an input stream.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I fd
	: file descriptor to read from
.IP "" 0
.IP _ 2
.I ln
	: line number
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if an IO error or a syntax error occured
.IP "" 0
else one parsed object from the stream.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EBADF
	: an invalid file descriptor war specified
.IP "" 0
.IP _ 2
.I EIO
	: a read error occured
.IP "" 0
.IP _ 2
.I ENOMEM
	: no memory was available
.IP "" 0
.IP _ 2
.I EINVAL
	: a syntax error occured
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Do not rely on the file descriptor offset to be anywhere usable or in relation
to the data read. The buffering scheme used does not allow this. This is a BUG,
and will be corrected in the future by repositioning the stream offset on file
streams. Pipe streams will remain bugged until FILE* reading is implemented.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ListScan
.PD 0


.I XCLE_List
.B XCLE_ListScan
(
.I XCLE_ParseCtx
.B contx
,
.I int
.B fd
,
.I unsigned
.I long
.B *
.B ln
) ;

.PD 1
.P
.PD
Parses a list from an input flux.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I fd
	: file descriptor to read from
.IP "" 0
.IP _ 2
.I ln
	: line number
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if an IO error or a syntax error occured
.IP "" 0
else the parsed List.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EBADF
	: an invalid file descriptor war specified
.IP "" 0
.IP _ 2
.I EIO
	: a read error occured
.IP "" 0
.IP _ 2
.I ENOMEM
	: no memory was available
.IP "" 0
.IP _ 2
.I EINVAL
	: a syntax error occured
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Do not rely on the file descriptor offset to be anywhere usable or in relation
to the data read. The buffering scheme used does not allow this. This is a BUG,
and will be corrected in the future by repositioning the stream offset on file
streams. Pipe streams will remain bugged until FILE* reading is implemented.
.RE
.PD 1
.P
.PD








