.TH XCLE_Mod_parse 3 "2006-02-22" Unix Libraries



.SH NAME
.I Parsing  module - Instructions manual
.PD 0
.P
.PD
-------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Parsing context definition



.PD 1
.P
.PD
.SS Function XCLE_ParseCtxAlloc
.PD 0


.I XCLE_ParseCtx
.B XCLE_ParseCtxAlloc
(
.B void
) ;

.PD 1
.P
.PD
Creates a new parsing context.

.B
	Returns
.RS
.IP _ 2
.I NULL
	: if memory allocation could not be performed
.IP "" 0
else a new XCLE_ParseCtx object.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ParseCtx_DescByName
.PD 0


.I const
.I char
.B *
.B XCLE_ParseCtx_DescByName
(
.I XCLE_ParseCtx
.B contx
,
.I char
.B *
.B str
) ;

.PD 1
.P
.PD
Finds a description for a Code name, looking for a definition in registered tables.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I str
	: string to look up in the tables
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the string or parsing context were NULL, or the string was not found in the tables
.IP "" 0
else a Code of name 'str', built from the related definition.
.RE
.PD 1
.P
.PD


.B
	NOTE
.RS
Use XCLE_CodeRegister to register instructions before calling XCLE_CodeByName.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ParseCtx_CodeByName
.PD 0


.I XCLE_Code
.B XCLE_ParseCtx_CodeByName
(
.I XCLE_ParseCtx
.B contx
,
.I char
.B *
.B str
) ;

.PD 1
.P
.PD
Creates a Code object by its name, looking for a definition in registered tables.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I str
	: string to look up in the tables
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the string or parsing context were NULL, or the string was not found in the tables
.IP "" 0
else a Code of name 'str', built from the related definition.
.RE
.PD 1
.P
.PD


.B
	NOTE
.RS
Use XCLE_CodeRegister to register instructions before calling XCLE_CodeByName.
.RE
.PD 1
.P
.PD






.SH Registry and Dynamic Loading



.PD 1
.P
.PD
.SS Function XCLE_CodeRegister
.PD 0


.I unsigned
.I long
.B XCLE_CodeRegister
(
.I XCLE_ParseCtx
.B contx
,
.I char
.B *
.B name
,
.I XCLE_CodeDef
.B *
.B table
,
.I unsigned
.I long
.B tablesize
) ;

.PD 1
.P
.PD
Registers a primitives module.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I name
	: module name
.IP "" 0
.IP _ 2
.I table
	: table of primitives definitions
.IP "" 0
.IP _ 2
.I tablesize
	: size of the definitions table
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if the parsing context, the module name or the table were NULL
.IP "" 0
.IP _ 2
.I 0
	: if the table was empty
.IP "" 0
else the number of modules registered.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if a reallocation failed
.IP "" 0
.IP _ 2
.I EINVAL
	: if the context was not properly defined, or the module name was NULL
.IP "" 0
.IP _ 2
.I EINVAL
	: if the table was NULL or empty
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_CodeUnregister
.PD 0


.I unsigned
.I long
.B XCLE_CodeUnegister
(
.I XCLE_ParseCtx
.B contx
,
.I char
.B *
.B name
) ;

.PD 1
.P
.PD
Unregisters a primitives module.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I name
	: module name
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if the parsing context or the module name were NULL
.IP "" 0
else the number of modules registered.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if a reallocation failed
.IP "" 0
.IP _ 2
.I EINVAL
	: if the context was not properly defined
.IP "" 0
.IP _ 2
.I EINVAL
	: if the module name was NULL or could not be found
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_CodeLoad
.PD 0


.I unsigned
.I long
.B XCLE_CodeLoad
(
.I XCLE_ParseCtx
.B contx
,
.I char
.B *
.B module
) ;

.PD 1
.P
.PD
Registers instruction definitions from a module file.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I module
	: file name of the module
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if the parsing context was NULL, or the module was invalid
.IP "" 0
else the size of the table.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if a reallocation failed
.IP "" 0
.IP _ 2
.I ENOENT
	: if the module was not found
.IP "" 0
.IP _ 2
.I EINVAL
	: if the context was not properly defined or the module structure invalid
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	NOTE
.RS
This loading interface asks for two symbol names to be defined in modules (shared
objects, or dynamically loaded libraries):
.IP _ 2
.I unsigned long XCL_Registry_Vers
	: a version identifier produced by XCLE_MAKEVERSIONID
.IP "" 0
.IP _ 2
.I unsigned long XCL_Registry_Size
	: the number of CodeDef objects defined by the module
.IP "" 0
.IP _ 2
.I XCLE_CodeDef XCL_Registry_Table
	: a table of CodeDef objects defining the module contents
.IP "" 0
To prevent loading of modules compiled with incompatibles versions of XCLE, the module is
loaded only if XCL_Registry_Vers matches XCLE_versionid() in their first two bytes.
Module developers should use the macro XCLE_MAKEVERSIONID with the major, minor and
release version number of the XCLE library they use to produce XCL_Registry_Vers.
.RE
.PD 1
.P
.PD






.SH Parsing



.PD 1
.P
.PD
.SS Function XCLE_ObjectParse
.PD 0


.I XCLE_Object
.B XCLE_ObjectParse
(
.I XCLE_ParseCtx
.B contx
,
.I char
.B *
.B str
,
.I unsigned
.I long
.B *
.B off
) ;

.PD 1
.P
.PD
Creates an object, from a character string object representation.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I str
	: string to parse
.IP "" 0
.IP _ 2
.I off
	: offset pointer in the string indicating where to begin (or NULL)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a syntax error occurred or the end of the string was reached
.IP "" 0
else the next parsed XCLE_Object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a syntax error occurred
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ListParse
.PD 0


.I XCLE_List
.B XCLE_ListParse
(
.I XCLE_ParseCtx
.B contx
,
.I char
.B *
.B str
,
.I unsigned
.I long
.B *
.B off
) ;

.PD 1
.P
.PD
Parses a string into a list of objects.

.B
	Args
.RS
.IP _ 2
.I contx
	: parsing context
.IP "" 0
.IP _ 2
.I str
	: string to parse
.IP "" 0
.IP _ 2
.I off
	: offset pointer in the string indicating where to begin (or NULL)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a syntax error occurred, or no object was found
.IP "" 0
else an XCLE_List of all recognised XCLE_Objects.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a syntax error occurred
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD







