.TH XCLE_Mod_prof 3 "2006-04-10" Unix Libraries



.SH NAME
.I Profiling  module - Instructions manual
.PD 0
.P
.PD
---------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Signature structure definition and memory management



.PD 1
.P
.PD
.SS Function XCLE_SignatureAlloc
.PD 0


.I XCLE_Signature
.B XCLE_SignatureAlloc
(
.B 
) ;

.PD 1
.P
.PD
Creates a new XCLE_Signature object.

.B
	Returns
.RS
.IP _ 2
.I NULL
	: if memory allocation could not be performed
.IP "" 0
a new XCLE_Signature object..
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureCopy
.PD 0


.I XCLE_Signature
.B XCLE_SignatureCopy
(
.I XCLE_Signature
.B sig
) ;

.PD 1
.P
.PD
Copies data from an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: the original object to copy
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available or an invalid signature was passed as argument
.IP "" 0
a complete copy of the 'sig' object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureFree
.PD 0


.I void
.B XCLE_SignatureFree
(
.I XCLE_Signature
.B sig
) ;

.PD 1
.P
.PD
Frees an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to free
.IP "" 0
.RE
.PD 1
.P
.PD






.SH Signature object accessors



.PD 1
.P
.PD
.SS Function XCLE_SignatureNum
.PD 0


.I unsigned
.I short
.B XCLE_SignatureNum
(
.I XCLE_Signature
.B sig
) ;

.PD 1
.P
.PD
Returns the number of signatures registered in the argument.

.B
	Args
.RS
.IP _ 2
.I sig
	: the XCLE_Signature object to query
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an invalid signature was passed as argument
.IP "" 0
the number of signatures in 'sig'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureArgc
.PD 0


.I unsigned
.I short
.B XCLE_SignatureArgc
(
.I XCLE_Signature
.B sig
,
.I unsigned
.I short
.B sign
) ;

.PD 1
.P
.PD
Returns the number of arguments for a specific signature in an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: the XCLE_Signature object to query
.IP "" 0
.IP _ 2
.I sign
	: the index number of the signature
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
the number of arguments for the signature at index 'sign'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid, or 'sign' was greater than the number of signatures in 'sig'
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureRetc
.PD 0


.I unsigned
.I short
.B XCLE_SignatureRetc
(
.I XCLE_Signature
.B sig
,
.I unsigned
.I short
.B sign
) ;

.PD 1
.P
.PD
Returns the number of returns for a specific signature in an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: the XCLE_Signature object to query
.IP "" 0
.IP _ 2
.I sign
	: the index number of the signature
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
the number of returns for the signature at index 'sign'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid, or 'sign' was greater than the number of signatures in 'sig'
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureArgt
.PD 0


.I XCLE_Type
.B XCLE_SignatureArgt
(
.I XCLE_Signature
.B sig
,
.I unsigned
.I short
.B sign
,
.I unsigned
.I short
.B argn
) ;

.PD 1
.P
.PD
Returns the type of an argument for a specific signature in an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: the XCLE_Signature object to query
.IP "" 0
.IP _ 2
.I sign
	: the index number of the signature
.IP "" 0
.IP _ 2
.I argn
	: the index number of the argument
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
the type of the 'argn'th argument for the signature at index 'sign'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid, or 'sign' was greater than the number of signatures in 'sig', or 'argn' was greater than the number of arguments for this signature
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureRett
.PD 0


.I XCLE_Type
.B XCLE_SignatureRett
(
.I XCLE_Signature
.B sig
,
.I unsigned
.I short
.B sign
,
.I unsigned
.I short
.B retn
) ;

.PD 1
.P
.PD
Returns the type of a return for a specific signature in an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: the XCLE_Signature object to query
.IP "" 0
.IP _ 2
.I sign
	: the index number of the signature
.IP "" 0
.IP _ 2
.I retn
	: the index number of the return
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
the type of the 'retn'th return for the signature at index 'sign'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid, or 'sign' was greater than the number of signatures in 'sig', or 'argn' was greater than the number of arguments for this signature
.IP "" 0
.RE
.PD 1
.P
.PD






.SH Signature constructors / content management



.PD 1
.P
.PD
.SS Function XCLE_SignatureExtract
.PD 0


.I XCLE_Signature
.B XCLE_SignatureExtract
(
.I XCLE_Code
.B cod
) ;

.PD 1
.P
.PD
Extracts the signatures from an XCLE_Code object.

.B
	Args
.RS
.IP _ 2
.I cod
	: XCLE_Code object to query
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available, or the XCLE_Code object was NULL or invalid
.IP "" 0
the signatures contained in 'cod'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.IP _ 2
.I EINVAL
	: if 'cod' was NULL or invalid
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureAdd
.PD 0


.I unsigned
.I short
.B XCLE_SignatureAdd
(
.I XCLE_Signature
.B sig
,
.I unsigned
.I short
.B argc
,
.I XCLE_Type
.B *
.B argt
,
.I unsigned
.I short
.B retc
,
.I XCLE_Type
.B *
.B rett
) ;

.PD 1
.P
.PD
Adds a signature to an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to modify
.IP "" 0
.IP _ 2
.I argc
	: number of arguments
.IP "" 0
.IP _ 2
.I argt
	: number of returns
.IP "" 0
.IP _ 2
.I retc
	: argument types list
.IP "" 0
.IP _ 2
.I rett
	: returns types list
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
the modified 'sig' object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Upon allocation with XCLE_SignatureAlloc, an XCLE_Signature starts with no registered
signature. As such, it will mean literally 'accepts no argument configuration, does not
return', i.e. something that can not be executed. XCLE_SignatureAdd must be used at least
once to make an XCLE_Signature usable. It can be used several times, meaning several
input/output configurations are acceptable.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureMatch
.PD 0


.I unsigned
.I short
.B XCLE_SignatureMatch
(
.I XCLE_Signature
.B sig
,
.I unsigned
.I short
.B argc
,
.I XCLE_Type
.B *
.B argt
,
.I unsigned
.I short
.B retc
,
.I XCLE_Type
.B *
.B rett
) ;

.PD 1
.P
.PD
Searches for a signature matching exactly the given argument and return types and numbers.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to test
.IP "" 0
.IP _ 2
.I argc
	: number of arguments
.IP "" 0
.IP _ 2
.I argt
	: number of returns
.IP "" 0
.IP _ 2
.I retc
	: types of arguments
.IP "" 0
.IP _ 2
.I rett
	: types of returns
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid
.IP "" 0
the index of a matching signature in 'sig'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_SignatureMatch is exactly looking for the index of a signature added using
XCLE_SignatureAdd with the same 'argc', 'argt', 'retc' and 'rett' arguments values.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureDel
.PD 0


.I unsigned
.I short
.B XCLE_SignatureDel
(
.I XCLE_Signature
.B sig
,
.I unsigned
.I short
.B sign
) ;

.PD 1
.P
.PD
Deletes a signature from an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to modify
.IP "" 0
.IP _ 2
.I sign
	: index number of the signature to delete
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid
.IP "" 0
the modified 'sig' argument.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
This deletes one signature from the list, changing the index numbers of other
signatures. XCLE_SignatureDel thus invalidates any previous signature index
obtained from 'sig' with the XCLE_SignatureMatch function, and decreases of 1
the return value of XCLE_SignatureNum.
.RE
.PD 1
.P
.PD






.SH Signature String conversion and printing



.PD 1
.P
.PD
.SS Function XCLE_SignatureToString
.PD 0


.I unsigned
.I long
.B XCLE_SignatureToString
(
.I XCLE_Signature
.B sig
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Produces a character string representation of an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to display
.IP "" 0
.IP _ 2
.I out
	: output character buffer, of size at least 'len'
.IP "" 0
.IP _ 2
.I len
	: maximum number of characters to write
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid
.IP "" 0
the  maximum number of characters needed to write completely the XCLE_Signature if 'out' is NULL, otherwise the number of characters written in 'out'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureWrite
.PD 0


.I unsigned
.I long
.B XCLE_SignatureWrite
(
.I XCLE_Signature
.B sig
,
.I XCLE_WriteHandler
.B wrt
,
.I void
.B *
.B dat
,
.I XCLE_WriteFormat
.B fmt
) ;

.PD 1
.P
.PD
Writing method for an XCLE_Signature.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to write
.IP "" 0
.IP _ 2
.I wrt
	: handler for the real write operation
.IP "" 0
.IP _ 2
.I dat
	: user-set data pointer to pass the handler
.IP "" 0
.IP _ 2
.I fmt
	: data formatting information
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if some error occurred
.IP "" 0
else total number of character needed, if 'wrt' is NULL, the total number of characters printed otherwise.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Signature was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
or any error generated by the 'wrt' handler
.RE
.PD 1
.P
.PD


.B
	Note
.RS
See [XCLE_Mod_write] for details on the XCLE_WriteHandler and XCLE_WriteFormat types.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignaturePrint
.PD 0


.I unsigned
.I long
.B XCLE_SignaturePrint
(
.I XCLE_Signature
.B sig
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Prints an XCLE_Signature on a file descriptor.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to print
.IP "" 0
.IP _ 2
.I fd
	: file descriptor
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid, or a write error occured
.IP "" 0
else the number of characters written on 'fd'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
any error generated by the 'write' system call on 'fd'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureFPrint
.PD 0


.I unsigned
.I long
.B XCLE_SignatureFPrint
(
.I XCLE_Signature
.B sig
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Prints an XCLE_Signature on a stream.

.B
	Args
.RS
.IP _ 2
.I sig
	: XCLE_Signature to print
.IP "" 0
.IP _ 2
.I os
	: output stream
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid, or a write error occured
.IP "" 0
else the number of characters written on 'os'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sig' was NULL or invalid
.IP "" 0
any error generated by the 'fwrite' system call on 'os'
.RE
.PD 1
.P
.PD






.SH Signature high-level API



.PD 1
.P
.PD
.SS Function XCLE_SignatureIsSub
.PD 0


.I unsigned
.I short
.B XCLE_SignatureIsSub
(
.I XCLE_Signature
.B sg1
,
.I XCLE_Signature
.B sg2
) ;

.PD 1
.P
.PD
Determines if an XCLE_Signature is a subset of another.

.B
	Args
.RS
.IP _ 2
.I sg1
	: candidate-subset XCLE_Signature
.IP "" 0
.IP _ 2
.I sg2
	: candidate-superset XCLE_Signature
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid
.IP "" 0
.IP _ 2
.I 0
	: if some signatures in 'sg1' were not in 'sg2'
.IP "" 0
.IP _ 2
.I 1
	: if ALL signatures in 'sg1' were also in 'sg2'
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sg1' or 'sg2' were NULL or invalid
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_SignatureIsSub is a partial order relation: XCLE_SignatureIsSub(sg1,sg2)==0 does not mean XCLE_SignatureIsSub(sg2,sg1)==1. The reverse is true, however, except when 'sg1' and 'sg2' are equal. When comparing type specifications, a type mask is a subset of another if any non-zero bit in the first one is also non-zero in the second one.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureEqual
.PD 0


.I unsigned
.I short
.B XCLE_SignatureEqual
(
.I XCLE_Signature
.B sg1
,
.I XCLE_Signature
.B sg2
) ;

.PD 1
.P
.PD
Tests the equality between two XCLE_Signature objects.

.B
	Args
.RS
.IP _ 2
.I sg1
	: first XCLE_Signature to test
.IP "" 0
.IP _ 2
.I sg2
	: second XCLE_Signature to test
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I 0
	: if only one argument was NULL, or the argument differed
.IP "" 0
.IP _ 2
.I 1
	: if both 'sg1' and 'sg2' were NULL, or they were equal
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Testing equality for XCLE_Signature objects means ensuring that every signature found in 'sg1' is also in 'sg2', and vice-versa. This means strict equality, and matching but not equal type masks count as distinct.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureCompat
.PD 0


.I unsigned
.I short
.B XCLE_SignatureCompat
(
.I XCLE_Signature
.B sg1
,
.I XCLE_Signature
.B sg2
) ;

.PD 1
.P
.PD
Tests for compatibility between signatures in XCLE_Signature objects.

.B
	Args
.RS
.IP _ 2
.I sg1
	: first XCLE_Signature
.IP "" 0
.IP _ 2
.I sg2
	: second XCLE_Signature
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if one of the arguments was NULL or invalid
.IP "" 0
.IP _ 2
.I 0
	: if 'sg2' is not compatible with 'sg1'
.IP "" 0
.IP _ 2
.I 1
	: if one argument signature in 'sg2' was compatible with one return signature in 'sg1'
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sg1' or 'sg2' were NULL or invalid
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Compatibility of 'sg2' with 'sg1' means than at least one signature in 'sg1' is compatible with at least one signature in 'sg2', i.e. a signature in 'sg1' which asks for, either:.
less arguments than a counterpart in 'sg1', and that all argument types match return types in that signature
more arguments than a counterpart in 'sg1', and that all return types match argument types in this signature
In both cases, overflow types (types that are in a position bigger than the smaller of the argument and return counts) are ignored.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureChain
.PD 0


.I XCLE_Signature
.B XCLE_SignatureChain
(
.I XCLE_Signature
.B sg1
,
.I XCLE_Signature
.B sg2
) ;

.PD 1
.P
.PD
Computes the resulting signatures when chaining XCLE_Signature objects.

.B
	Args
.RS
.IP _ 2
.I sg1
	: first XCLE_Signature
.IP "" 0
.IP _ 2
.I sg2
	: second XCLE_Signature
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if an error occured
.IP "" 0
else .
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'sg1' or 'sg2' were NULL or invalid
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Chaining two signatures meaning keeping only compatible couples of signatures in 'sg1' and 'sg2', and discarding matching return sections in 'sg1' signatures, and argument sections in 'sg2' signatures. Overflow arguments from 'sg2' are added to argument signatures in the results, and overflow returns from 'sg1' are added to retrurn signatures in the results.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_SignatureCompute
.PD 0


.I XCLE_Signature
.B XCLE_SignatureCompute
(
.I XCLE_List
.B lst
) ;

.PD 1
.P
.PD
Computes the global signatures of the elements of an XCLE_List.

.B
	Args
.RS
.IP _ 2
.I lst
	: XCLE_List to profile
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if an error occured
.IP "" 0
else the chain of all extracted signatures from elements in 'lst'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if 'lst' was NULL or invalid
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Each element in the list is converted into a signature. All types except XCLE_Code have a signle signature, taking no argument and returning that type. Signatures are extracted from XCLE_Code object using XCLE_SignatureExtract. The chain is then computed from the left onward, in associative manner.
.RE
.PD 1
.P
.PD







