.TH XCLE_Mod_string 3 "2006-02-22" Unix Libraries



.SH NAME
.I String conversion module - Instructions manual
.PD 0
.P
.PD
----------------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Canonical object string representation



.PD 1
.P
.PD
.SS Function XCLE_ObjectToString
.PD 0


.I unsigned
.I long
.B XCLE_ObjectToString
(
.I XCLE_Object
.B obj
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Writes a character string representation of a generic object.

.B
	Args
.RS
.IP _ 2
.I obj
	: object to write
.IP "" 0
.IP _ 2
.I out
	: output string (allocated for at least len+1 characters)
.IP "" 0
.IP _ 2
.I len
	: max number of characters to write
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occurred
.IP "" 0
the maximum number of characters needed to write completely the object if 'out' is NULL (len is ignored)
else the total number of characters written.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL XCLE_Object was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_VoidToString
.PD 0


.I unsigned
.I long
.B XCLE_VoidToString
(
.I XCLE_Void
.B vd
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Writes a Void object representation into a string: ''.

.B
	Args
.RS
.IP _ 2
.I vd
	: Void object to write
.IP "" 0
.IP _ 2
.I out
	: output string
.IP "" 0
.IP _ 2
.I len
	: max number of characters to write, trailing '\0' excluded
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occured
.IP "" 0
.IP _ 2
.I 1
	: if 'out' was NULL or len>=1
.IP "" 0
.IP _ 2
.I 0
	: if 'out' was non-NULL and len was zero
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Void was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgToString
.PD 0


.I unsigned
.I long
.B XCLE_IntgToString
(
.I XCLE_Intg
.B in
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Writes an Intg object representation into a character string.

.B
	Args
.RS
.IP _ 2
.I in
	: Intg object to write
.IP "" 0
.IP _ 2
.I out
	: output string
.IP "" 0
.IP _ 2
.I len
	: maximum number of characters to write, trailing '\0' excluded
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
the number of characters needed to write an Intg, if 'out' was NULL
else the number of character written (10/11, or up to len).
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Intg was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpToString
.PD 0


.I unsigned
.I long
.B XCLE_FltpToString
(
.I XCLE_Fltp
.B fp
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Writes a Fltp object representation into a character string.

.B
	Args
.RS
.IP _ 2
.I fp
	: Fltp object to write
.IP "" 0
.IP _ 2
.I out
	: output string
.IP "" 0
.IP _ 2
.I len
	: maximum number of characters to write, trailing '\0' excluded
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
the maximum number of characters needed, if 'out' was NULL
else the number of characters written.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgToString
.PD 0


.I unsigned
.I long
.B XCLE_StrgToString
(
.I XCLE_Strg
.B str
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Writes a Strg object representation into a character string.

.B
	Args
.RS
str
out
len
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ListToString
.PD 0


.I unsigned
.I long
.B XCLE_ListToString
(
.I XCLE_List
.B lst
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Writes a List object representation into a character string.

.B
	Args
.RS
.IP _ 2
.I lst
	: List object to write
.IP "" 0
.IP _ 2
.I out
	: output character string (allocated for at least len+1 characters)
.IP "" 0
.IP _ 2
.I len
	: maximum number of characters to write
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if a NULL List was passed as argument
.IP "" 0
the maximum number of characters neede to write this List, if 'out' was NULL
else the number of characters written.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL List was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_CodeToString
.PD 0


.I unsigned
.I long
.B XCLE_CodeToString
(
.I XCLE_Code
.B cod
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B len
) ;

.PD 1
.P
.PD
Writes a Code object representation into a character string.

.B
	Args
.RS
.IP _ 2
.I cod
	: Code to write
.IP "" 0
.IP _ 2
.I out
	: output string (allocated for at least len+1 characters)
.IP "" 0
.IP _ 2
.I len
	: maximum number of character to write
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a NULL Code was passed as argument
.IP "" 0
the number of characters neeede to write completely the Code, if 'out' was NULL
else the total number of characters written.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Code was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD









.PD 1
.P
.PD
.SS Function XCLE_StackToString
.PD 0


.I unsigned
.I long
.B XCLE_StackToString
(
.I XCLE_Stack
.B stk
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B max
,
.I char
.B *
.B head
,
.I char
.B *
.B rowfmt
,
.I char
.B *
.B tail
,
.I unsigned
.I long
.B rows
) ;

.PD 1
.P
.PD
Prints the contents of an Stack, following the given formats.

.B
	Args
.RS
.IP _ 2
.I stk
	: Stack to print
.IP "" 0
.IP _ 2
.I out
	: output character string
.IP "" 0
.IP _ 2
.I max
	: maximum number of characters to print (final nil char EXCEPTED)
.IP "" 0
.IP _ 2
.I head
	: head string
.IP "" 0
.IP _ 2
.I rowfmt
	: row printing format
.IP "" 0
.IP _ 2
.I tail
	: tail string
.IP "" 0
.IP _ 2
.I rows
	: number of rows (height in chars)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if the Stack was NULL
.IP "" 0
the total number of characters that should be printed, if 'out' was NULL.
else the number of characters printed.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Stack was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The row format string is printed for each stack row between 0 and rows-1.
Escape sequences take the form %fdd..dd?, where the 'f' char is an optionnal
fill character (by dfault ' '), 'd' chars are digits and '?' denotes either
the 'n' or 's' characters. They are replaced by the stack row number, for the 'n'
format, and the corresponding object, for the 's' format, each written on
the number of chars denoted by the digits.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_HashToString
.PD 0


.I unsigned
.I long
.B XCLE_HashToString
(
.I XCLE_Hash
.B nms
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B max
,
.I char
.B *
.B head
,
.I char
.B *
.B rowfmt
,
.I char
.B *
.B tail
) ;

.PD 1
.P
.PD
Prints a Hash keys and contents, acording to formats.

.B
	Args
.RS
.IP _ 2
.I nms
	: Hash to print
.IP "" 0
.IP _ 2
.I out
	: output character string
.IP "" 0
.IP _ 2
.I max
	: maximum number of characters to print (final nil char EXCEPTED)
.IP "" 0
.IP _ 2
.I head
	: head string
.IP "" 0
.IP _ 2
.I rowfmt
	: row printing format
.IP "" 0
.IP _ 2
.I tail
	: tail string
.IP "" 0
.IP _ 2
.I rows
	: number of rows (height in chars)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if the Hash was NULL
.IP "" 0
the total number of characters that should be printed, if 'out' was NULL.
else the number of characters printed.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Hash was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The row format string is printed for each name entry in the Hash.
Escape sequences take the form %fdd..dd?, where the 'f' char is an optionnal
fill character (by dfault ' '), 'd' chars are digits and '?' denotes either
the 'n' or 's' characters. They are replaced by the entry name, for the 'n'
format, and the corresponding object, for the 's' format, each written on
the number of chars denoted by the digits.
.RE
.PD 1
.P
.PD







