.TH XCLE_Obj_fltp 3 "2006-02-22" Unix Libraries



.SH NAME
.I Fltp Object structure and methods - Instructions manual
.PD 0
.P
.PD
-------------------------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH XCLE_Fltp object type



.PD 1
.P
.PD
.SS Function XCLE_FltpAlloc
.PD 0


.I XCLE_Fltp
.B XCLE_FltpAlloc
(
.B void
) ;

.PD 1
.P
.PD
Allocates a new Fltp object with value zero.

.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else the allocated Fltp, with value zero.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The Fltp object type is a double precision floating point number.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpCopy
.PD 0


.I XCLE_Fltp
.B XCLE_FltpCopy
(
.I XCLE_Fltp
.B fp
) ;

.PD 1
.P
.PD
Copies a Fltp object.

.B
	Args
.RS
.IP _ 2
.I fp
	: Fltp object to copy
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Fltp object with the same value as 'fp'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_FltpCopy and XCLE_FltpClone do exactly the same thing
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpClone
.PD 0


.I XCLE_Fltp
.B XCLE_FltpClone
(
.I XCLE_Fltp
.B fp
) ;

.PD 1
.P
.PD
Clones a Fltp object.

.B
	Args
.RS
.IP _ 2
.I fp
	: Fltp object to clone
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Fltp object with the same value as 'fp'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_FltpCopy and XCLE_FltpClone do exactly the same thing
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpFree
.PD 0


.I void
.B XCLE_FltpFree
(
.I XCLE_Fltp
.B in
) ;

.PD 1
.P
.PD
Frees an Fltp object.

.B
	Args
.RS
.IP _ 2
.I in
	: Fltp object to free
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpNew
.PD 0


.I XCLE_Fltp
.B XCLE_FltpNew
(
.I double
.B nb
) ;

.PD 1
.P
.PD
Creates a new Fltp object from a floating point value.

.B
	Args
.RS
.IP _ 2
.I nb
	: value to give to the new object
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Fltp object with value 'nb'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpEqual
.PD 0


.I unsigned
.I char
.B XCLE_FltpEqual
(
.I XCLE_Fltp
.B fp
,
.I XCLE_Fltp
.B fpw
) ;

.PD 1
.P
.PD
Compares two Fltp objects.

.B
	Args
.RS
.IP _ 2
.I fp
	: Fltp object to compare
.IP "" 0
.IP _ 2
.I fpw
	: reference Fltp object
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if a NULL Fltp was passed as argument
.IP "" 0
.IP _ 2
.I 0
	: if the two Fltp objects had distinct values
.IP "" 0
.IP _ 2
.I +1
	: if the two Fltp objects had the same value
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_FltpValue
.PD 0


.I double
.B XCLE_FltpValue
(
.I XCLE_Fltp
.B fp
) ;

.PD 1
.P
.PD
Retrives the value of a Fltp object.

.B
	Args
.RS
.IP _ 2
.I in
	: Fltp to query
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I 0
	: if a NULL Fltp was passed as argument
.IP "" 0
else the floating point value if the Fltp object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Fltp was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD








