.TH XCLE_Obj_generic 3 "2006-02-22" Unix Libraries



.SH NAME
.I Generic Object Container - Instructions manual
.PD 0
.P
.PD
----------------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Object type definitions



.PD 1
.P
.PD
.SS Macro XCLE_OT_VOID
.PD 0
XCLE_OT_VOID
.PD 1
.P
.PD
The Void type identifier.




.PD 1
.P
.PD
.SS Macro XCLE_OT_INTG
.PD 0
XCLE_OT_INTG
.PD 1
.P
.PD
The Intg type identifier.




.PD 1
.P
.PD
.SS Macro XCLE_OT_FLTP
.PD 0
XCLE_OT_FLTP
.PD 1
.P
.PD
The Fltp type identifier.




.PD 1
.P
.PD
.SS Macro XCLE_OT_STRG
.PD 0
XCLE_OT_STRG
.PD 1
.P
.PD
The Strg type identifier.




.PD 1
.P
.PD
.SS Macro XCLE_OT_LIST
.PD 0
XCLE_OT_LIST
.PD 1
.P
.PD
The List type identifier.




.PD 1
.P
.PD
.SS Macro XCLE_OT_CODE
.PD 0
XCLE_OT_CODE
.PD 1
.P
.PD
The Code type identifier.





.SH Generic Object methods



.PD 1
.P
.PD
.SS Function XCLE_ObjectAlloc
.PD 0


.I XCLE_Object
.B XCLE_ObjectAlloc
(
.I XCLE_Type
.B typ
) ;

.PD 1
.P
.PD
Allocates an empty, undefined object.

.B
	Args
.RS
.IP _ 2
.I typ
	: the type of object to allocate
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available or the type was not recognized
.IP "" 0
else a new XCLE_Object of type 'typ'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	OOPS
.RS
Something was wrong here
.RE
.PD 1
.P
.PD


















.PD 1
.P
.PD
.SS Function XCLE_ObjectClone
.PD 0


.I XCLE_Object
.B XCLE_ObjectClone
(
.I XCLE_Object
.B obj
) ;

.PD 1
.P
.PD
Clones an object.

.B
	Args
.RS
.IP _ 2
.I obj
	: object to clone
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a NULL object was passed as argument, or no memory was available
.IP "" 0
else a cloned version of the object (flat copy).
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL object was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	OOPS
.RS
Something was wrong here
.RE
.PD 1
.P
.PD














.PD 1
.P
.PD
.SS Function XCLE_ObjectDnRef
.PD 0


.I XCLE_Object
.B XCLE_ObjectDnRef
(
.I XCLE_Object
.B obj
) ;

.PD 1
.P
.PD
Decreases the references count of an object.

.B
	Args
.RS
.IP _ 2
.I obj
	: XCLE_Object to dereference
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if a NULL object was passed as argument
.IP "" 0
else the dereferenced object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL object was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ObjectFree
.PD 0


.I void
.B XCLE_ObjectFree
(
.I XCLE_Object
.B obj
) ;

.PD 1
.P
.PD
Frees an object if it is unreferenced.

.B
	Args
.RS
.IP _ 2
.I obj
	: object to free
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The object is freed if and only if its reference count has fallen to zero, meaning
no other referenced object and no object storage structure contains it anymore.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ObjectType
.PD 0


.I XCLE_Type
.B XCLE_ObjectType
(
.I XCLE_Object
.B obj
) ;

.PD 1
.P
.PD
Returns the type of an object.

.B
	Args
.RS
.IP _ 2
.I obj
	: object to query
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if a NULL object was passed as argument
.IP "" 0
else the numeric identifier for the object's type.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL object was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ObjectTypeName
.PD 0


.I char
.B *
.B XCLE_ObjectTypeName
(
.I XCLE_Type
.B typ
) ;

.PD 1
.P
.PD
Returns a name for a numeric type identifier.

.B
	Args
.RS
.IP _ 2
.I typ
	: numeric identifier for a type
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I ""
	: if an unknown type was given
.IP "" 0
else a string name for that type.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ObjectEqual
.PD 0


.I unsigned
.I char
.B XCLE_ObjectEqual
(
.I XCLE_Object
.B obj
,
.I XCLE_Object
.B objw
) ;

.PD 1
.P
.PD
Tests the equality between objects.

.B
	Args
.RS
.IP _ 2
.I obj
	: object to test
.IP "" 0
.IP _ 2
.I objw
	: reference object
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if a NULL object was passed as argument
.IP "" 0
.IP _ 2
.I 0
	: if the two objects were distinct
.IP "" 0
.IP _ 2
.I +1
	: if the two objects were equal
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL object was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Macro XCLE_AnyToObject
.PD 0
XCLE_Object XCLE_AnyToObject(XCLE_<Type> obj) ;
.PD 1
.P
.PD
Converts any object into its generic version.

.B
	Args
.RS
.IP _ 2
.I obj
	: object to convert
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
a generic object containing 'obj'
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_ObjectTo<Type>
.PD 0
XCLE_<Type> XCLE_ObjectTo<Type>(XCLE_Object obj) ;
.PD 1
.P
.PD
Transforms a generic object into a <Type> object, checking that the conversion is possible.

.B
	Args
.RS
.IP _ 2
.I obj
	: the object to convert
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if the object was NULL, or of a different type
.IP "" 0
else the converted object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if the object was NULL, or of an incompatible type
.IP "" 0
.RE
.PD 1
.P
.PD








