.TH XCLE_Obj_intg 3 "2006-02-22" Unix Libraries



.SH NAME
.I Intg Object structure and methods - Instructions manual
.PD 0
.P
.PD
-------------------------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH XCLE_Intg object type



.PD 1
.P
.PD
.SS Function XCLE_IntgAlloc
.PD 0


.I XCLE_Intg
.B XCLE_IntgAlloc
(
.B void
) ;

.PD 1
.P
.PD
Allocates a new Intg object, with value zero.

.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Intg object with value zero.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The Intg object type is a double capacity (64 bits) integer.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgCopy
.PD 0


.I XCLE_Intg
.B XCLE_IntgCopy
(
.I XCLE_Intg
.B in
) ;

.PD 1
.P
.PD
Copies the given Intg.

.B
	Args
.RS
.IP _ 2
.I in
	: the object to copy
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Intg whose value is the same as 'in'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Void was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_IntgCopy and XCLE_IntgClone do exactly the same thing.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgClone
.PD 0


.I XCLE_Intg
.B XCLE_IntgClone
(
.I XCLE_Intg
.B in
) ;

.PD 1
.P
.PD
Clones the given Intg.

.B
	Args
.RS
.IP _ 2
.I in
	: the object to clone
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Intg whose value is the same as 'in'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Void was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_IntgCopy and XCLE_IntgClone do exactly the same thing.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgFree
.PD 0


.I void
.B XCLE_IntgFree
(
.I XCLE_Intg
.B in
) ;

.PD 1
.P
.PD
Frees an Intg object.

.B
	Args
.RS
.IP _ 2
.I in
	: Intg object to free
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgNew
.PD 0


.I XCLE_Intg
.B XCLE_IntgNew
(
.I long
.B nb
) ;

.PD 1
.P
.PD
Creates an Intg object from an integer value.

.B
	Args
.RS
.IP _ 2
.I nb
	: value to give to the new object
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Intg whose value is 'nb'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgEqual
.PD 0


.I unsigned
.I char
.B XCLE_IntgEqual
(
.I XCLE_Intg
.B in
,
.I XCLE_Intg
.B inw
) ;

.PD 1
.P
.PD
Compares two Intg.

.B
	Args
.RS
.IP _ 2
.I in
	: Intg to compare
.IP "" 0
.IP _ 2
.I inw
	: reference Intg
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if a NULL Intg was passed as argument
.IP "" 0
.IP _ 2
.I 0
	: if the two Intg have distinct values
.IP "" 0
+1            " if the two Intg have the same value
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Intg was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_IntgValue
.PD 0


.I long
.B XCLE_IntgValue
(
.I XCLE_Intg
.B in
) ;

.PD 1
.P
.PD
Retrives the value of an Intg object.

.B
	Args
.RS
.IP _ 2
.I in
	: Intg to query
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I 0
	: if a NULL Intg was passed as argument
.IP "" 0
else the integer value if the Intg object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Intg was passed as argument
.IP "" 0
.RE
.PD 1
.P
.PD








