.TH XCLE_Obj_strg 3 "2006-02-22" Unix Libraries



.SH NAME
.I Strg Object structure and methods - Instructions manual
.PD 0
.P
.PD
-------------------------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH XCLE_Strg object type



.PD 1
.P
.PD
.SS Function XCLE_StrgAlloc
.PD 0


.I XCLE_Strg
.B XCLE_StrgAlloc
(
.I unsigned
.I long
.B size
) ;

.PD 1
.P
.PD
Allocates a new Strg object.

.B
	Args
.RS
.IP _ 2
.I size
	: length of allocated Strg
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Strg object, with length 'size', and filled with '\0' chars.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgCopy
.PD 0


.I XCLE_Strg
.B XCLE_StrgCopy
(
.I XCLE_Strg
.B str
) ;

.PD 1
.P
.PD
Copies a Strg object.

.B
	Args
.RS
.IP _ 2
.I str
	: Strg object to copy
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a complete copy of 'str'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_StrgCopy and XCLE_StrgClone do exactly the same thing.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgClone
.PD 0


.I XCLE_Strg
.B XCLE_StrgClone
(
.I XCLE_Strg
.B str
) ;

.PD 1
.P
.PD
Clones a Strg object.

.B
	Args
.RS
.IP _ 2
.I str
	: Strg object to clone
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a complete copy of 'str'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
XCLE_StrgCopy and XCLE_StrgClone do exactly the same thing.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgFree
.PD 0


.I void
.B XCLE_StrgFree
(
.I XCLE_Strg
.B str
) ;

.PD 1
.P
.PD
Frees a Strg object.

.B
	Args
.RS
.IP _ 2
.I str
	: Strg object to free
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgNew
.PD 0


.I XCLE_Strg
.B XCLE_StrgNew
(
.I char
.B *
.B chs
) ;

.PD 1
.P
.PD
Creates a Strg object from a character string (C convention, '\0'-terminated).

.B
	Args
.RS
.IP _ 2
.I chs
	: character string to initialize the object from
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available or 'chs' was NULL.
.IP "" 0
else a Strg object with the same characters as 'chs'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL string was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgLen
.PD 0


.I unsigned
.I long
.B XCLE_StrgLen
(
.I XCLE_Strg
.B str
) ;

.PD 1
.P
.PD
Returns the length of a Strg object.

.B
	Args
.RS
.IP _ 2
.I str
	: Strg object to query
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
-1             : if 'str' was NULL
else the Strg length.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgCat
.PD 0


.I XCLE_Strg
.B XCLE_StrgCat
(
.I XCLE_Strg
.B str1
,
.I XCLE_Strg
.B str2
) ;

.PD 1
.P
.PD
Concatenes two Strg objects, in the arguments' order.

.B
	Args
.RS
.IP _ 2
.I str1
	: first part of the concatenated string
.IP "" 0
.IP _ 2
.I str2
	: last part of the concatenated string
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else the concatenation.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgCut
.PD 0


.I XCLE_Strg
.B XCLE_StrgCut
(
.I XCLE_Strg
.B str
,
.I unsigned
.I long
.B beg
,
.I unsigned
.I long
.B end
) ;

.PD 1
.P
.PD
Extracts a portion of a Strg object.

.B
	Args
.RS
.IP _ 2
.I str
	: Strg object to cut from
.IP "" 0
.IP _ 2
.I beg
	: index of first character of extracted part (beginning at 0)
.IP "" 0
.IP _ 2
.I end
	: index of first character after extracted part
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available, or 'beg' > 'end'
.IP "" 0
a new Strg made form the extracted section.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgEqual
.PD 0


.I unsigned
.I char
.B XCLE_StrgEqual
(
.I XCLE_Strg
.B str
,
.I XCLE_Strg
.B strw
) ;

.PD 1
.P
.PD
Compares two Strg object.

.B
	Args
.RS
.IP _ 2
.I str
	: Strg object to compare
.IP "" 0
.IP _ 2
.I strw
	: reference Strg object
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I 0
	: if the two Strg were different
.IP "" 0
.IP _ 2
.I +1
	: if the two Strg were equal
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_StrgValue
.PD 0


.I unsigned
.I long
.B XCLE_StrgValue
(
.I XCLE_Strg
.B str
,
.I char
.B *
.B out
,
.I unsigned
.I long
.B max
) ;

.PD 1
.P
.PD
Outputs a Strg characters into a character string.

.B
	Args
.RS
.IP _ 2
.I str
	: Strg to copy
.IP "" 0
.IP _ 2
.I out
	: output character string
.IP "" 0
.IP _ 2
.I max
	: maximum number of characters to write
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if no memory was available, a NULL Strg or character string was passed
.IP "" 0
else the number of character written.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Strg or character string was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
This method is distinct from XCLE_StrgOut in that it does not output a representation
of the Strg as an object (i.e. with quotes, and special characters escaped) but the
exact string buffer contents.
.RE
.PD 1
.P
.PD








