.TH XCLE_Obj_void 3 "2006-02-22" Unix Libraries



.SH NAME
.I Void Object structure and methods - Instructions manual
.PD 0
.P
.PD
-------------------------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH XCLE_Void object type



.PD 1
.P
.PD
.SS Function XCLE_VoidAlloc
.PD 0


.I XCLE_Void
.B XCLE_VoidNew
(
.B void
) ;

.PD 1
.P
.PD
Allocates a new Void object.

.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a new Void object.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if a NULL Void was passed as argument
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
A Void object retains no individual information. It is simply an undefined object.
As such, no Copy and Clone methods are needed. Note that the numeric identifier
for a Void object is 0, to provide a simple default object type.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_VoidFree
.PD 0


.I void
.B XCLE_VoidFree
(
.I XCLE_Void
.B vd
) ;

.PD 1
.P
.PD
Frees a Void object.

.B
	Args
.RS
.IP _ 2
.I vd
	: Void object to free
.IP "" 0
.RE
.PD 1
.P
.PD








