.TH XCLE_Splash 3 "2006-02-22" Unix Libraries



.SH NAME
.I Splash text utilities - Instructions manual
.PD 0
.P
.PD
-------------------------------------------


. XCLE:  eXtensible Concatenative Language Engine
. Copyright (C) 2000-2006 Yann LANDRIN-SCHWEITZER a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH XCLE_Splash utilities



.PD 1
.P
.PD
.SS Function XCLE_versionid
.PD 0


.I unsigned
.I long
.B XCLE_versionid
(
.B void
) ;

.PD 1
.P
.PD
Returns a binary identifier for the current version of XCLE.

.B
	Returns
.RS
A binary version identifier.
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The version identifier is composed of the major version number, on the
first byte, the minor version number on the second byte, and the release
number on the third byte.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_version
.PD 0


.I const
.I char
.B *
.B XCLE_version
(
.B void
) ;

.PD 1
.P
.PD
Returns a version string for the current version of XCLE.

.B
	Returns
.RS
A string version identifier.
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The version identifier takes the form "X.Y.Z", where X is the major version
number, Y the minor version number and Z the release number.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_copyright
.PD 0


.I const
.I char
.B *
.B XCLE_copyright
(
.B void
) ;

.PD 1
.P
.PD
Returns a copyright string for the XCLE library.

.B
	Returns
.RS
The copyright string for XCLE.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_license
.PD 0


.I const
.I char
.B *
.B XCLE_license
(
.B void
) ;

.PD 1
.P
.PD
Returns a short license information for the XCLE library.

.B
	Returns
.RS
The string "XCLE is distributed under the LGPL License"
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_splash
.PD 0


.I const
.I char
.B *
.B XCLE_splash
(
.B void
) ;

.PD 1
.P
.PD
Returns the full name of the XCLE library.

.B
	Returns
.RS
The string "XCLE: eXtensible Concatenative Language Engine"
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_author
.PD 0


.I const
.I char
.B *
.B XCLE_author
(
.B void
) ;

.PD 1
.P
.PD
Returns the author(s) name and contact information.

.B
	Returns
.RS
A string containing one author record per line.
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Each author record should contain, separaed by double dashes:
the author's full name,
the author's mail address,
the author's web page.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function XCLE_syntax
.PD 0


.I const
.I char
.B *
.B XCLE_syntax
(
.B void
) ;

.PD 1
.P
.PD
Returns a long string displaying basic synatx information for the XCL language.

.B
	Returns
.RS
A string containing one object recor dper line.
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Each line contains each object's type, common name, class and typical
string representation.
.RE
.PD 1
.P
.PD







